(function () {

  'use strict';



  /**
   * Requiring dependancies.
   */

  var
    autoprefixer = require( 'autoprefixer' ),
    flexbugs     = require( 'postcss-flexbugs-fixes' ),
    fontMagician = require( 'postcss-font-magician' ),
    mqpacker     = require( 'css-mqpacker' ),
    rucksack     = require( 'rucksack-css' ),
    systemFont   = require( 'postcss-font-family-system-ui' ),
    poststylus   = require( 'poststylus' );



  /**
   * Defining PostCSS plugins options.
   */

  var
    options = {};



  /**
   * Defining PostCSS dependancies.
   */

  var
    postcssPlugins = [
      autoprefixer,
      flexbugs,
      fontMagician,
      mqpacker,
      rucksack,
      systemFont
    ];



  /**
   * Defining PostCSS plugin for Stylus.
   */

  var
    postcss = function () {
      return poststylus( postcssPlugins );
    };



  /**
   * Defining task configurations.
   */

  var
    task = {
      target    : {
        options : {
          use      : [ postcss ],
          compress : false
        },

        files: {
          'dist/cascader.css': 'src/cascader.styl'
        }
      }
    };



  /**
   * Exporting task.
   */

  module.exports = task;

})();
