// ---------------------------------------------------------
// @Utils
// ---------------------------------------------------------

/**
 * Extending Element Prototype
 */

Element.prototype.toggleClasses = function ( prop ) {
  for (var i = 0, len = prop.length; i < len; i++) {
    this.classList.toggle( prop[i] );
  }
};








// ---------------------------------------------------------
// @Accordion
// ---------------------------------------------------------

(function () {
  'use strict';

  // #Component Variables
  // -------------------------------------

  var
    touchSupported   = ('ontouchstart' in window),
    pointerSupported = ('pointerdown' in window),

    trigger = document.querySelectorAll('.c-accordion__trigger');



  // #Component Functions
  // -------------------------------------

  /**
   * Function used to remove tap delay
   * on touch devices.
   */

  function skipClickDelay(event) {
    event.preventDefault();
    event.target.click();
  }


  /**
   * Function used to switch between different accordion
   * on user click.
   */

  function switchAccordion(event) {
    event.preventDefault();

    var
      thisTrigger = this,
      thisContent = thisTrigger.nextElementSibling;

    thisTrigger.toggleClasses(['is-collapsed', 'is-expanded']);
    thisContent.toggleClasses(['is-collapsed', 'is-expanded']);
  }



  // #Intialization
  // -------------------------------------

  /**
   * Adding event listeners.
   */

  for (var i = 0, len = trigger.length; i < len; i++) {

    /**
     * Skip click delay.
     */
    touchSupported && trigger[i].addEventListener( 'touchstart', skipClickDelay, false );
    pointerSupported && trigger[i].addEventListener( 'pointerdown', skipClickDelay, false );


    /**
     * Trigger click event listener.
     */

    trigger[i].addEventListener( 'click', switchAccordion, false );
  }
})();
