// ---------------------------------------------------------
// @Menu
// ---------------------------------------------------------

(function () {
  'use strict';

  /**
   * Stop event bubbling when clicking links to prevent
   * toggling `is-active` class when clicking menu items
   * that doesn't contain dropdowns.
   */

  var
    links = document.querySelectorAll('.c-menu__item');

  for (var i = 0; i < links.length; i++) {
    links[i].addEventListener('click', function (e) {
      e.preventDefault();
      e.stopPropagation();

      this.classList.toggle('is-active');
    });
  }



  /**
   * Dropdown trigger function
   */

  var
    triggers  = document.querySelectorAll('.fn-dropdownTrigger'),
    dropdowns = document.querySelectorAll('.c-menu--dropdown');

  for (var i = 0; i < triggers.length; i++) {

    triggers[i].addEventListener('click', function (event) {
      event.preventDefault();

      var
        _this    = event.target,
        dropdown = _this.nextElementSibling;

      for (var i = dropdowns.length - 1; i >= 0; i--) {
        dropdowns[i].classList.remove('is-visible');
      }

      dropdown.classList.add('is-visible');

      document.addEventListener('click', dropdownDismiss);

      function dropdownDismiss(event) {
        if (!event.target.classList.contains('fn-dropdownTrigger') && !event.target.classList.contains('c-menu--dropdown') ) {
           document.removeEventListener('click', dropdownDismiss);
           dropdown.classList.remove('is-visible');
        }
      }
    });
  }
})();
